$if not setglobal debug $offlisting offinclude
$ontext

     XLEXPORT: A GAMS to Excel Ordered Data Export Utility

                     (an interface to XLLINK.EXE)

Usage:

     $LIBINCLUDE XLEXPORT ident[.suffix] xlfile range [/m]

N.B.  Data transfer takes place at execution time.

$offtext

$if setglobal xl_system $goto countargs
$setglobal xl_system 'operating'
$echo %system.gstring%     >xllink.log
$echo XLLINK Activity Log >>xllink.log
$label countargs

$hidden         Begin by checking that the parameter exists:

$if a%5 == a  $goto startcheck
$error XLEXPORT extra argument = %5
$log *** XLEXPORT incorrect call
$exit

$label startcheck
$if not a%3 == a  $goto checkfile
$error XLEXPORT arguments missing data=%1 xlfile=%2 range=%3 options=%4
$log *** XLEXPORT incorrect call
$exit

$label checkfile
$if exist %2  $goto checkdata
$error XLEXPORT file missing = %2
$log *** XLEXPORT missing spreadsheet file
$exit

$label checkdata
$if declared %1 $goto declared
$error XLEXPORT data item no found = %1
$log *** XLEXPORT data item not found
$exit

$label declared
$if defined %1 $goto defined
$error XLEXPORT data item not defined = %1
$log *** XLEXPORT data item not defined
$exit

$label defined
$if not a%3 == %3 $goto checkopt
$error XLEXPORT spreadsheet range not specified
$log *** XLEXPORT spreadsheet range not specified -- use XLDUMP
$abort 

$label checkopt
$if  a%4 == a  $goto start
$if  %4 == /M  $goto start
$if  %4 == /m  $goto start
$error XLEXPORT invalid option %4.    The only recognized option is /m 
$log *** XLEXPORT invalid option %4.  The only recognized option is /m 
$abort 

$label start
$setlocal data   '%1'
$setlocal xlfile '%2'
$setlocal range  '%3'

$set newfile '%gams.scrdir%xllink.scr'
$if not setglobal oldfile $setglobal oldfile ''
$if '%oldfile%' == '%newfile%' $goto fileok
$setglobal oldfile %newfile%
$if declared xllink_tmp $kill xllink_tmp
file xllink_tmp / %newfile% /;

$label fileok
$if not declared xllink_tmp file xllink_tmp / %newfile% /;
put xllink_tmp;
$setglobal timestamp no
$libinclude gams2txt %data%
$setglobal timestamp yes
putclose;

$set newcmdfile '%gams.scrdir%xlcmd.scr'
$if not setglobal oldcmdfile $setglobal oldcmdfile ''
$if '%oldcmdfile%' == '%newcmdfile%' $goto cmdfileok
$setglobal oldcmdfile %newcmdfile%
$if declared xllink_cmd $kill xllink_cmd
file xllink_cmd / %newcmdfile% /;
$label cmdfileok

$if dimension 0 %data% $set dimen 0
$if dimension 1 %data% $set dimen 1 
$if dimension 2 %data% $set dimen 2 
$if dimension 3 %data% $set dimen 3 
$if dimension 4 %data% $set dimen 4 
$if dimension 5 %data% $set dimen 5 
$if dimension 6 %data% $set dimen 6 
$if dimension 7 %data% $set dimen 7 
$if dimension 8 %data% $set dimen 8 
$if dimension 9 %data% $set dimen 9 
$if dimension 10 %data% $set dimen 10

putclose xllink_cmd, '%newfile%'/'%xlfile%'/'%dimen%'//'%range%'/'/l'/'%4';

execute 'echo --- Exporting "%data%" to "%xlfile%" into range "%range%"';
execute 'echo  XLEXPORT %1 %2 %3 %4 >>xllink.log';
if (execerror ne 0, execerror = 0);
execute '=%gams.sdir%xllink %newcmdfile% xllink.log';
if (execerror ne 0,
  display "An XLLINK execution error occured following invocation:",
          "         XLEXPORT %1 %2 %3 %4",
          "See XLLINK.LOG for an error code.";
  execute 'echo === XLLINK command file:>>xllink.log';
  execute 'copy xllink.log+%newcmdfile% xllink.log >nul';
$if setglobal abortxlerr  abort "Exiting GAMS program";
  display  "Continuing with GAMS program.";
  execerror = 0;
);
execute 'del %newcmdfile%';

